## crack 5.0a

=== Makefile ===
###
# This program was written by and is copyright Alec Muffett 1991,
# 1992, 1993, 1994, 1995, and 1996, and is provided as part of the
# Crack v5.0 Password Cracking package.
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENCE"
# document which accompanies distributions of Crack v5.0 and upwards.
###

all:
	@echo ""
	@echo "Please don't run 'make' yourself."
	@echo "Invoke 'Crack' to do it for you."
	@echo ""
	@echo "If you don't understand how to do this,"
	@echo "Then read the documentation."
	@echo ""
	@echo "If you still don't understand this,"
	@echo "then go fetch a guru to help."
	@echo ""
	@echo "If the guru doesn't understand,"
	@echo "get a new guru..."
	@echo ""

utils:  library
	@( cd src/util && make $(ARGS) || exit 1 )

library:
	@( cd src/lib && make $(ARGS) || exit 1 )

clean:
	-find . -name "*~" -print | xargs -n50 rm -f
	-( cd src; for dir in * ; do ( cd $$dir ; make clean ) ; done )
#	-make ARGS=clean utils
# skip this last one 'cos "clean" is a simple target caught by the loop

tidy: clean
	-scripts/plaster
	-scripts/fbmerge
	-rm -f run/[DIEGTKM]*
	-rm -f run/dict/gecos.*
	-rm -f run/dict/gcperm.*

spotless: tidy
	-rm -rf run/bin

rmdict:
	-rm -rf run/dict

clobber: spotless rmdict
	-cat run/F-merged >> F-merged.save
	-rm -rf run
	( cd extra ; make clean )

=== src/lib/Makefile ===
###
# This program was written by and is copyright Alec Muffett 1991,
# 1992, 1993, 1994, 1995, and 1996, and is provided as part of the
# Crack v5.0 Password Cracking package.
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENCE"
# document which accompanies distributions of Crack v5.0 and upwards.
###

XLIB=	$(XDIR)/libc5.a
CFLAGS= $(XCFLAGS)
CC=	$(XCC)

SRC=	dawglib.c debug.c rules.c stringlib.c
OBJ=	dawglib.o debug.o rules.o stringlib.o

$(XLIB): $(SRC) ../lib/libcrack.h
	( make "XDIR=$(XDIR)" "XCFLAGS=$(XCFLAGS)" $(OBJ) || exit 1 )	
	ar rv $(XLIB) $(OBJ)
	-ranlib $(XLIB)
	@echo all made in lib

clean:
	rm -f $(OBJ) *~

clobber: clean
	rm -f $(XLIB)

../lib/libcrack.h:

=== src/libdes/Makefile ===
# You must select the correct terminal control system to be used to
# turn character echo off when reading passwords.  There a 5 systems
# SGTTY   - the old BSD system
# TERMIO  - most system V boxes
# TERMIOS - SGI (ala IRIX).
# VMS     - the DEC operating system
# MSDOS   - we all know what it is :-)
# read_pwd.c makes a reasonable guess at what is correct.

# If you are on a DEC Alpha, edit des.h and change the DES_LONG
# define to 'unsigned int'.  I have seen this give a %20 speedup.

OPTS0= -DRAND -DTERMIO #-DNOCONST

# Version 1.94 has changed the strings_to_key function so that it is
# now compatible with MITs when the string is longer than 8 characters.
# If you wish to keep the old version, uncomment the following line.
# This will affect the -E/-D options on des(1).
#OPTS1= -DOLD_STR_TO_KEY

# This #define specifies the use of an alternative D_ENCRYPT macro in
# ecb_encrypt.  The choice of macro can make a %20 difference in the
# speed.  Unfortunatly the choise of the best macro appears to be very
# dependant on the compiler and the machine in question.
# For the following combinations use the ALT_ECB option.
# Sparc 2 (cc -O4), sun 3/260 (cc -O4)
# For the following combinations do not use the ALT_ECB option.
# Sparc 2 (gcc2 -O2), sun 3/260 (cc -O2), mvax2 (cc -O), MSDOS (Turbo Cv2)
# For other machines, experiment with changing the option and run
# ./speed to see which is faster.
# DO NOT TURN THIS OPTION ON WHEN COMPILING THIS CODE ON A 64 BIT MACHINE
# 12-Apr-1996 - It appears to be broken and I'm not bothering to fix
# it right now, so don't use this option :-)
#OPTS2= -DDES_PTR

OPTS= $(OPTS0) $(OPTS1) $(OPTS2)

CC=cc
CFLAGS= -O $(OPTS) $(CFLAG)

#CC=gcc
#CFLAGS= -O4 -fomit-frame-pointer -funroll-loops $(OPTS) $(CFLAG)

LIBDIR=/usr/local/lib
BINDIR=/usr/local/bin
INCDIR=/usr/local/include
MANDIR=/usr/local/man
MAN1=1
MAN3=3
SHELL=/bin/sh
OBJS=	cbc3_enc.o cbc_cksm.o cbc_enc.o ncbc_enc.o pcbc_enc.o qud_cksm.o \
	cfb64ede.o cfb64enc.o cfb_enc.o ecb3_enc.o ecb_enc.o  ede_enc.o  \
	enc_read.o enc_writ.o fcrypt.o  ofb64ede.o ofb64enc.o ofb_enc.o  \
	rand_key.o read_pwd.o set_key.o rpc_enc.o  str2key.o supp.o

GENERAL=COPYRIGHT FILES INSTALL Imakefile README VERSION Makefile \
	times vms.com KERBEROS MODES.DES  GNUmakefile des.man \
	DES.pm DES.pod DES.xs Makefile.PL Makefile.uni typemap t \
	des_crypt.man Makefile.ssl des.doc makefile.bc des.org \
	des_locl.org
DES=	des.c
TESTING=destest.c speed.c rpw.c
HEADERS=version.h des.h des_locl.h podd.h sk.h spr.h rpc_des.h
LIBDES= cbc3_enc.c cbc_cksm.c cbc_enc.c ncbc_enc.c pcbc_enc.c qud_cksm.c \
	cfb64ede.c cfb64enc.c cfb_enc.c ecb3_enc.c ecb_enc.c  ede_enc.c  \
	enc_read.c enc_writ.c fcrypt.c  ofb64ede.c ofb64enc.c ofb_enc.c  \
	rand_key.c read_pwd.c set_key.c rpc_enc.c  str2key.c  supp.c

PERL=	des.pl testdes.pl doIP doPC1 doPC2 PC1 PC2 shifts.pl

ALL=	$(GENERAL) $(DES) $(TESTING) $(LIBDES) $(PERL) $(HEADERS)

DLIB=	libdes.a

all: $(DLIB) destest rpw des speed

test:	all
	./destest

$(DLIB): $(OBJS)
	/bin/rm -f $(DLIB)
	ar cr $(DLIB) $(OBJS)
	-if test -s /bin/ranlib; then /bin/ranlib $(DLIB); \
	else if test -s /usr/bin/ranlib; then /usr/bin/ranlib $(DLIB); \
	else exit 0; fi; fi

destest: destest.o libdes.a
	$(CC) $(CFLAGS) -o destest destest.o libdes.a

rpw: rpw.o libdes.a
	$(CC) $(CFLAGS) -o rpw rpw.o libdes.a

speed: speed.o libdes.a
	$(CC) $(CFLAGS) -o speed speed.o libdes.a

des: des.o libdes.a
	$(CC) $(CFLAGS) -o des des.o libdes.a

tags:
	ctags $(DES) $(TESTING) $(LIBDES)

tar:
	tar chf libdes.tar $(ALL)

shar:
	shar $(ALL) >libdes.shar

depend:
	makedepend $(LIBDES) $(DES) $(TESTING)

clean:
	/bin/rm -f *.o tags core rpw destest des speed $(DLIB) .nfs* *.old \
	*.bak destest rpw des speed

dclean:
	sed -e '/^# DO NOT DELETE THIS LINE/ q' Makefile >Makefile.new
	mv -f Makefile.new Makefile

# Eric is probably going to choke when he next looks at this --tjh
install: $(DLIB) des
	if test $(INSTALLTOP); then \
	    echo SSL style install; \
	    cp $(DLIB) $(INSTALLTOP)/lib; \
	    if test -s /bin/ranlib; then \
	        /bin/ranlib $(INSTALLTOP)/lib/$(DLIB); \
	    else \
		if test -s /usr/bin/ranlib; then \
		/usr/bin/ranlib $(INSTALLTOP)/lib/$(DLIB); \
	    fi; fi; \
	    chmod 644 $(INSTALLTOP)/lib/$(DLIB); \
	    cp des.h $(INSTALLTOP)/include; \
	    chmod 644 $(INSTALLTOP)/include/des.h; \
	    cp des $(INSTALLTOP)/bin; \
	    chmod 755 $(INSTALLTOP)/bin/des; \
	else \
	    echo Standalone install; \
	    cp $(DLIB) $(LIBDIR)/$(DLIB); \
	    if test -s /bin/ranlib; then \
	      /bin/ranlib $(LIBDIR)/$(DLIB); \
	    else \
	      if test -s /usr/bin/ranlib; then \
		/usr/bin/ranlib $(LIBDIR)/$(DLIB); \
	      fi; \
	    fi; \
	    chmod 644 $(LIBDIR)/$(DLIB); \
	    cp des $(BINDIR)/des; \
	    chmod 711 $(BINDIR)/des; \
	    cp des_crypt.man $(MANDIR)/man$(MAN3)/des_crypt.$(MAN3); \
	    chmod 644 $(MANDIR)/man$(MAN3)/des_crypt.$(MAN3); \
	    cp des.man $(MANDIR)/man$(MAN1)/des.$(MAN1); \
	    chmod 644 $(MANDIR)/man$(MAN1)/des.$(MAN1); \
	    cp des.h $(INCDIR)/des.h; \
	    chmod 644 $(INCDIR)/des.h; \
	fi
# DO NOT DELETE THIS LINE -- make depend depends on it.

=== debian/changelog ===
crack (5.0a-19) unstable; urgency=medium

  * Team upload.
  * Add autopkgtests.
  * d/control:
    - Add "libcrypt-dev" to Build-Depends (Closes: #1106983).
    - Remove Breaks and Replaces regarding ancient versions of crack.
    - Remove "Rules-Requires-Root: no", it's the standard nowadays.
  * d/Crack.make, d/p/Makefile.patch:
    - Fix passing the same build flags multiple times.
  * d/p/Makefile.patch:
    - Make sure src/libdes receives the same build flags as the rest of the
      source code.
    - Make sure src/libdes receives no CPPFLAGS duplicates.
  * d/p/*:
    - Update headers to modern DEP-3.
    - Add "Forwarded: not-needed" where missing.
    - Add field "Bug-Debian" where missing.
  * d/crack.lintian-overrides, d/crack-md5.lintian-overrides:
    - Get rid of lintian no-manual-page warning.
  * d/watch:
    - Convert it to version 5 format.
    - Rework Matching-Pattern making heavy use of special strings.

 -- Sven Geuer <sge@debian.org>  Wed, 17 Sep 2025 17:10:05 +0200

crack (5.0a-18) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with GCC-15 (Closes: #1096474).
    - /d/p/fix-incompatible-pointer-types.patch: Add one more fix required to
      make GCC-15 happy.
    - d/p/fix-more-function-declaration-errors.patch: Add this patch to fix
      several function declarations GCC-15 complains about.

 -- Sven Geuer <sge@debian.org>  Thu, 11 Sep 2025 22:45:29 +0200

crack (5.0a-17) unstable; urgency=medium

  * Team upload.
  * d/crack.links: Drop link /usr/share/Crack/conf (Closes: #1100678).
  * d/copyright: Bump Debian copyright years to 2025.
  * d/control: Bump Standards-Version to 4.7.2.
  * d/gbp.conf: Switch debian-branch to debian/unstable.

 -- Sven Geuer <sge@debian.org>  Mon, 17 Mar 2025 16:48:33 +0100

crack (5.0a-16) unstable; urgency=medium

  * Team upload.
  * d/p/fix-incompatible-pointer-types.patch:
    - Add patch correcting "long" to "time_t" to fix ftbfs with
      architectures armel, armhf, hppa, sh4 and x32.

 -- Sven Geuer <sge@debian.org>  Sun, 18 Aug 2024 12:44:50 +0200

crack (5.0a-15) unstable; urgency=medium

  * Team upload.
  * Add missing "Team upload." to previous changelog entry.
  * d/p/add-missing-stdlib.h.patch, d/p/fix-implicit-int.patch:
    - Add patches to fix ftbfs with gcc-14 (Closes: #1074890).
  * d/u/metadata: Rework metadata to comply with DEP-12.
  * d/control:
    - Update Homepage field.
    - Bump Standards-Version to 4.7.0.
  * d/copyright:
    Add email of upstream author Mark Murray.
    Add missing copyright holders to the debian/* stanza.

 -- Sven Geuer <sge@debian.org>  Sat, 17 Aug 2024 22:02:51 +0200

crack (5.0a-14) unstable; urgency=medium

  * Team upload.
  * Fix implicit-function-declaration errors. (Closes: #1066634)

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 27 May 2024 11:31:52 +0700

crack (5.0a-13.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Vagrant Cascadian ]
  * debian/Crack.make: Use dpkg-buildflags to set default CFLAGS.
    (Closes: #1021521)
  * src/util/Makefile: Remove embedded timestamps. (Closes: #1021522)

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dpkg's buildtools.mk seed CC. (Closes: #952791)

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Tue, 19 Dec 2023 15:43:43 -0800

crack (5.0a-13) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.

  [ Giovani Augusto Ferreira ]
  * Using new DH level format. Consequently:
      - debian/compat: removed.
      - debian/control: changed from 'debhelper 11' to 'debhelper-compat' in
        Build-Depends field and bumped level to 13.
  * dedian/Crack.make: added some GCC flags to improve hardening.
  * debian/control:
      - Added the field Rules-Requires-Root: no.
      - Bumped Standards version to 4.5.1.
  * debian/copyright: updated the packaging rights and years.
  * debian/source/lintian-overrides: removed, this uneedded now.
  * debian/watch: updated to secure URI.

  [ Samuel Henrique ]
  * Add salsa-ci.yml
  * Configure git-buildpackage for Debian

 -- Giovani Augusto Ferreira <giovani@debian.org>  Wed, 03 Feb 2021 18:09:40 -0300

crack (5.0a-12) unstable; urgency=medium

  [ Raphaël Hertzog ]
  * Update team maintainer address to Debian Security Tools
    <team+pkg-security@tracker.debian.org>
  * Update Vcs-Git and Vcs-Browser for the move to salsa.debian.org

  [ Giovani Augusto Ferreira ]
  * Update my email address
  * Bumped DH level to 11
  * Bumped Standards-Version to 4.1.4
  * Added upstream metadata file

 -- Giovani Augusto Ferreira <giovani@debian.org>  Tue, 05 Jun 2018 16:28:16 -0300

crack (5.0a-11) unstable; urgency=medium

  * New Maintainer. (Closes: #840047)
  * Acknowledge NMUs. (Closes: #380540, #387756, #668897,
                               #817319, #817411, #821976)
  * debian/control:
      - Added Vcs-* fields to new repository of forensics team.
      - Removed virtual package wordlist from Recommends field.
  * debian/copyright:
      - Update authors and years in packaging copyright place.
  * debian/patches/b64_shebang.patch:
      - Update patch header.
  * debian/patches/fix-spelling.patch:
      - Created to fix spelling error in some files.
  * debian/rules:
      - Removed the "-pie" to improve the GCC hardening.
      - Removed useless comments.

 -- Giovani Augusto Ferreira <giovani@riseup.net>  Sun, 16 Oct 2016 17:50:27 -0200

crack (5.0a-10) unstable; urgency=low

  * QA upload.
    + Set Maintainer to Debian QA Group. (See #840047)
    + Create collab-maint git repo and add according Vcs-* headers.
  * Revamp debian/rules:
    + Drop now obsolete manual setting of variables like CFLAGS, etc.
    + Switch to a minimal dh v7 style debian/rules file.
    + Use debian/clean instead of manual calls to rm in clean target.
    + Use dh_auto_clean instead of manual call to make.
    + Replace override_dh_{auto_install,install{docs,examples,man}} with
      debian/crack*.{docs,examples,manpages,link,install}.


=== debian/control ===
Source: crack
Section: admin
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Giovani Augusto Ferreira <giovani@debian.org>
Build-Depends: debhelper-compat (= 13),
               libcrypt-dev
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/pkg-security-team/crack.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/crack
Homepage: https://alecmuffett.com/alecm/software/crack/

Package: crack-common
Architecture: all
Depends: make,
         ${misc:Depends}
Description: Password guessing program (common files of all variants)
 Crack is program designed to quickly locate vulnerabilities
 in Unix (or other) password files by scanning the contents
 of a password file, looking for users who have misguidedly
 chosen a weak login password.
 .
 This package provides the common files for the crypt() and
 MD5 versions.

Package: crack
Architecture: any
Depends: crack-common,
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: crack-md5
Description: Password guessing program (crypt() variant)
 Crack is program designed to quickly locate vulnerabilities
 in Unix (or other) password files by scanning the contents
 of a password file, looking for users who have misguidedly
 chosen a weak login password.
 .
 This package provides the runtime files for the crypt() version.

Package: crack-md5
Architecture: any
Depends: crack-common,
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: crack
Provides: crack
Description: Password guessing program (MD5 variant)
 Crack is program designed to quickly locate vulnerabilities
 in Unix (or other) password files by scanning the contents
 of a password file, looking for users who have misguidedly
 chosen a weak login password.
 .
 This package provides the runtime files for the MD5 version.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
DPKG_EXPORT_BUILDTOOLS=1
include /usr/share/dpkg/buildtools.mk

%:
	dh $@

override_dh_auto_build:
	debian/Crack.make
	# this is the crypt version, move it to other place
	mv lib/bin/debian/ lib/bin/debian-crypt
	# To build the MD5 version
	mv src/libdes src/libdes.orig
	cd src/util && cp elcid.c elcid.c.orig && cp elcid.c,bsd elcid.c
	debian/Crack.make
	mv lib/bin/debian/ lib/bin/debian-md5
	# Now restore it to the previous situation
	mv src/libdes.orig src/libdes
	cd src/util && cp elcid.c.orig elcid.c

override_dh_auto_clean:
	# This is done just in case
	if [ -d src/libdes.orig ] ; then \
	 mv src/libdes.orig src/libdes ; \
	 cd src/util && cp elcid.c.orig elcid.c ;\
	fi
	dh_auto_clean -- spotless

=== debian/tests/control ===
Tests: descrypt-crack
Depends: crack
Restrictions: needs-root

Tests: md5-crack
Depends: crack-md5
Restrictions: needs-root

=== debian/watch ===
Version: 5

Source: https://dropsafe.crypticide.com/alecm/software/crack/
Matching-Pattern: @PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
